generic: Verify the inheritance behavior of FS_XFLAG_DAX flag in various combinations
[xfstests-dev.git] / tests / generic / 112
1 #! /bin/bash
2 # SPDX-License-Identifier: GPL-2.0
3 # Copyright (c) 2005 Silicon Graphics, Inc.  All Rights Reserved.
4 #
5 # FS QA Test No. 112
6 #
7 # fsx (AIO variant, based on 075)
8 #
9 seq=`basename $0`
10 seqres=$RESULT_DIR/$seq
11 echo "QA output created by $seq"
12
13 here=`pwd`
14 tmp=/tmp/$$
15 status=0        # success is the default!
16 trap "_cleanup; exit \$status" 0 1 2 3 15
17
18 _cleanup()
19 {
20     cd /
21     rm -rf $TEST_DIR/fsx.* $tmp.*
22 }
23
24 # get standard environment, filters and checks
25 . ./common/rc
26 . ./common/filter
27
28 _do_test()
29 {
30     _n="$1"
31     _param="$2"
32
33     out=$TEST_DIR/fsx
34     rm -rf $out
35     if ! mkdir $out
36     then
37         echo "    failed to mkdir $out"
38         status=1
39         exit
40     fi
41
42     _filter_param=`echo "$_param" | sed\
43         -e 's/-N [0-9][0-9]*/-N numops/' \
44         -e 's/-l [0-9][0-9]*/-l filelen/'`
45
46     echo ""
47     echo "-----------------------------------------------"
48     echo "fsx.$_n : $_filter_param"
49     echo "-----------------------------------------------"
50
51     # Skip the prealloc runs if the file system does not support preallocation
52     if [ "$_n" = "1" -o "$_n" = "3" ]; then
53         if [ -n "$testio" ]; then
54             return
55         fi
56     fi
57
58     # This cd and use of -P gets full debug on "$RESULT_DIR" (not TEST_DEV)
59     cd $out
60     if ! $here/ltp/fsx $_param -P "$RESULT_DIR" $FSX_AVOID $seq.$_n &>/dev/null
61     then
62         echo "    fsx ($_param) returned $? - see $seq.$_n.full"
63         mv "$RESULT_DIR"/$seq.$_n.fsxlog $seqres.$_n.full
64         status=1
65         exit
66     fi
67
68     cd $here
69     _check_test_fs
70 }
71
72 _usage()
73 {
74     echo "$0: [-l filelen] [-n numops1] [-N numops2]"
75 }
76
77 _process_args()
78 {
79     OPTIND=1
80     while getopts "l:n:N:?" c $@
81     do
82         case $c
83         in
84             l)
85                 filelen=$OPTARG
86                 param_type="$param_type, overidde -l"
87                 ;;
88             N)
89                 numops2=$OPTARG
90                 param_type="$param_type, overidde -N"
91                 ;;
92             n)
93                 numops1=$OPTARG
94                 param_type="$param_type, overidde -n"
95                 ;;
96             ?)
97                 _usage
98                 exit    
99                 ;;
100         esac
101     done
102 }
103
104 # real QA test starts here
105 _supported_fs generic
106 _supported_os Linux
107 _require_test
108 _require_aio
109
110 [ -x $here/ltp/aio-stress ] || \
111         _notrun "fsx not built with AIO for this platform"
112
113 size10=`expr 10 \* 1024 \* 1024`        # 10 megabytes
114 filelen=$size10
115 numops1=1000
116 numops2=10000
117
118 # can override the params here
119 _process_args "$@"
120
121 echo "Params are for $param_type" >>$seqres.full
122 echo "Params: n = $numops1 N = $numops2 l = $filelen" >>$seqres.full
123
124 rm -f $seqres.full
125 echo "brevity is wit..."
126
127 _check_test_fs
128
129 # check if preallocation is supported, xfs_io resvsp command only prints out
130 # messages on failure.
131 testfile=$TEST_DIR/$$.xfs_io
132 testio=`$XFS_IO_PROG -f -c "resvsp 0 1" $testfile 2>&1`
133 rm -f $testfile 2>&1 > /dev/null
134
135 # Options:
136 # -d: debug output for all operations
137 # -l flen: the upper bound on file size (default 262144)
138 # -o oplen: the upper bound on operation size
139 # -N numops: total # operations to do (default infinity)
140 # -P: save .fsxlog and .fsxgood files in dirpath (default ./)
141 # -S seed: for random # generator (default 1) 0 gets timestamp
142 # -x: pre-allocate file space, exercising unwritten extents
143 # -A: use the AIO system calls
144
145 _do_test 0 "-A -d -N $numops1 -S 0"
146 _do_test 1 "-A -d -N $numops1 -S 0 -x"
147 _do_test 2 "-A -d -N $numops2 -l $filelen -S 0"
148 _do_test 3 "-A -d -N $numops2 -l $filelen -S 0 -x"
149
150 rm -f $seq.*.fsx{good,log}
151 exit 0